using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine;
using UnityEngine.UI;
using System.Linq;
using TMPro;
using UnityEngine.Events;

//BASE SCRIPT
namespace Fard
{

public class Fard
    {
        public static void Main()
        {

CategoryBuilder.Create("Happy Tree Friends PPG", "Happy tree friends mod for ppg, made by LazyL and Rawtor ;)", ModAPI.LoadSprite("sprites/thumb.png"));

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Cuddles",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "This adorable bunny rabbit is so darned cute you'll just want to squeeze him with all your heart.",
                    CategoryOverride = ModAPI.FindCategory("Happy Tree Friends PPG"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Cuddles.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var skin = ModAPI.LoadTexture("sprites/Cuddles.png");
                     
                        var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                        
                        var bone = ModAPI.LoadTexture("sprites/bone.png");
                     
                        person.SetBodyTextures(skin, flesh, bone, 4);

                        var head = Instance.transform.GetChild(5);
                        var cObj = new GameObject("hair");
                        cObj.transform.SetParent(Instance.transform.Find("Head"));
                        cObj.transform.localPosition = new Vector3(0f, 0f);
                        cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj.transform.localScale = new Vector3(0.5f, 0.5f);
                        var cSpr = cObj.AddComponent<SpriteRenderer>();
                        cSpr.sprite = ModAPI.LoadSprite("sprites/CuddlesEar.png");
                        cSpr.sortingLayerName = "Middle";

                        var tail1 = Instance.transform.GetChild(5);
                        var cObj1 = new GameObject("tails");
                        cObj1.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        cObj1.transform.localPosition = new Vector3(-0.30f, 0f);
                        cObj1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj1.transform.localScale = new Vector3(1f, 1f);
                        var cSpr1 = cObj1.AddComponent<SpriteRenderer>();
                        cSpr1.sprite = ModAPI.LoadSprite("sprites/CuddlesTail.png");
                        cSpr1.sortingLayerName = "Middle";
                     }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Flaky",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "Wherever there's trouble, this dandruff-laden porcupine is sure to be far, far away.",
                    CategoryOverride = ModAPI.FindCategory("Happy Tree Friends PPG"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Flaky.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var skin = ModAPI.LoadTexture("sprites/Flaky.png");
                     
                        var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                        
                        var bone = ModAPI.LoadTexture("sprites/bone.png");
                     
                        person.SetBodyTextures(skin, flesh, bone, 4);

                        var head = Instance.transform.GetChild(5);
                        var cObj = new GameObject("hair");
                        cObj.transform.SetParent(Instance.transform.Find("Head"));
                        cObj.transform.localPosition = new Vector3(0f, 0f);
                        cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj.transform.localScale = new Vector3(0.5f, 0.5f);
                        var cSpr = cObj.AddComponent<SpriteRenderer>();
                        cSpr.sprite = ModAPI.LoadSprite("sprites/FlakyH.png");
                        cSpr.sortingLayerName = "Middle";

                        var tail1 = Instance.transform.GetChild(5);
                        var cObj1 = new GameObject("tails");
                        cObj1.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        cObj1.transform.localPosition = new Vector3(-0.30f, 0f);
                        cObj1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj1.transform.localScale = new Vector3(1f, 1f);
                        var cSpr1 = cObj1.AddComponent<SpriteRenderer>();
                        cSpr1.sprite = ModAPI.LoadSprite("sprites/FlakyT.png");
                        cSpr1.sortingLayerName = "Middle";
                     }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Flippy",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "This emotionally tattered bear veteran will warm your home and leave no witnesses.",
                    CategoryOverride = ModAPI.FindCategory("Happy Tree Friends PPG"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Flippy.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var skin = ModAPI.LoadTexture("sprites/Flippy.png");
                     
                        var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                        
                        var bone = ModAPI.LoadTexture("sprites/bone.png");
                     
                        person.SetBodyTextures(skin, flesh, bone, 4);

                        var head = Instance.transform.GetChild(5);
                        var cObj = new GameObject("hair");
                        cObj.transform.SetParent(Instance.transform.Find("Head"));
                        cObj.transform.localPosition = new Vector3(0f, 0f);
                        cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj.transform.localScale = new Vector3(0.5f, 0.5f);
                        var cSpr = cObj.AddComponent<SpriteRenderer>();
                        cSpr.sprite = ModAPI.LoadSprite("sprites/FlippyHat.png");
                        cSpr.sortingLayerName = "Middle";

                     }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Fliqpy",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = " Flippy's violent alter ego and the main antagonist in the Happy Tree Friends series.",
                    CategoryOverride = ModAPI.FindCategory("Happy Tree Friends PPG"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Fliqpy.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var skin = ModAPI.LoadTexture("sprites/Fliqpy.png");
                     
                        var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                        
                        var bone = ModAPI.LoadTexture("sprites/bone.png");
                     
                        person.SetBodyTextures(skin, flesh, bone, 4);

                        var head = Instance.transform.GetChild(5);
                        var cObj = new GameObject("hair");
                        cObj.transform.SetParent(Instance.transform.Find("Head"));
                        cObj.transform.localPosition = new Vector3(0f, 0f);
                        cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj.transform.localScale = new Vector3(0.5f, 0.5f);
                        var cSpr = cObj.AddComponent<SpriteRenderer>();
                        cSpr.sprite = ModAPI.LoadSprite("sprites/FlippyHat.png");
                        cSpr.sortingLayerName = "Middle";

                     }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Giggles",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "Shy and sweet, this little chipmunk's trademark is her bubbly and giggly personality.",
                    CategoryOverride = ModAPI.FindCategory("Happy Tree Friends PPG"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Giggles.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var skin = ModAPI.LoadTexture("sprites/Giggles.png");
                     
                        var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                        
                        var bone = ModAPI.LoadTexture("sprites/bone.png");
                     
                        person.SetBodyTextures(skin, flesh, bone, 4);

                        var head = Instance.transform.GetChild(5);
                        var cObj = new GameObject("hair");
                        cObj.transform.SetParent(Instance.transform.Find("Head"));
                        cObj.transform.localPosition = new Vector3(0f, 0f);
                        cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj.transform.localScale = new Vector3(0.5f, 0.5f);
                        var cSpr = cObj.AddComponent<SpriteRenderer>();
                        cSpr.sprite = ModAPI.LoadSprite("sprites/GigglesBow.png");
                        cSpr.sortingLayerName = "Middle";

                     }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Handy",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "There's no job too big for this beaver carpenter. He's always eager to lend a helping... limb.",
                    CategoryOverride = ModAPI.FindCategory("Happy Tree Friends PPG"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Handy.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var skin = ModAPI.LoadTexture("sprites/Handy.png");
                     
                        var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                        
                        var bone = ModAPI.LoadTexture("sprites/bone.png");
                     
                        person.SetBodyTextures(skin, flesh, bone, 4);

                        var head = Instance.transform.GetChild(5);
                        var cObj = new GameObject("hair");
                        cObj.transform.SetParent(Instance.transform.Find("Head"));
                        cObj.transform.localPosition = new Vector3(0f, 0f);
                        cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj.transform.localScale = new Vector3(0.5f, 0.5f);
                        var cSpr = cObj.AddComponent<SpriteRenderer>();
                        cSpr.sprite = ModAPI.LoadSprite("sprites/HandyHat.png");
                        cSpr.sortingLayerName = "Middle";

                        var tail1 = Instance.transform.GetChild(5);
                        var cObj1 = new GameObject("tails");
                        cObj1.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        cObj1.transform.localPosition = new Vector3(-0.30f, 0f);
                        cObj1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj1.transform.localScale = new Vector3(1f, 1f);
                        var cSpr1 = cObj1.AddComponent<SpriteRenderer>();
                        cSpr1.sprite = ModAPI.LoadSprite("sprites/HandyT.png");
                        cSpr1.sortingLayerName = "Middle";

                        Instance.transform.Find("BackArm").Find("LowerArm").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
                        Instance.transform.Find("FrontArm").Find("LowerArmFront").gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();

                     }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Lumpy",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "This big, blue moose is all heart... and all thumbs! He'll be sure to keep you in stitches!",
                    CategoryOverride = ModAPI.FindCategory("Happy Tree Friends PPG"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Lumpy.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var skin = ModAPI.LoadTexture("sprites/Lumpy.png");
                     
                        var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                        
                        var bone = ModAPI.LoadTexture("sprites/bone.png");
                     
                        person.SetBodyTextures(skin, flesh, bone, 4);

                        var head = Instance.transform.GetChild(5);
                        var cObj = new GameObject("hair");
                        cObj.transform.SetParent(Instance.transform.Find("Head"));
                        cObj.transform.localPosition = new Vector3(0f, 0f);
                        cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj.transform.localScale = new Vector3(0.5f, 0.5f);
                        var cSpr = cObj.AddComponent<SpriteRenderer>();
                        cSpr.sprite = ModAPI.LoadSprite("sprites/LumpyHead.png");
                        cSpr.sortingLayerName = "Middle";

                        foreach (var limb in person.Limbs)
                        {
                            var HumanSprites = limb.gameObject.GetOrAddComponent<RandomHumanTextureBehaviour>();
                            HumanSprites.person = person;
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("sprites/Lumpy.png")); 
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("sprites/LumpyDerp.png")); 
                    
 

                        }

                     }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Nutty",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "This jittery squirrel has the biggest sugar-tooth! He's so sweet that you'll get cavities.",
                    CategoryOverride = ModAPI.FindCategory("Happy Tree Friends PPG"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Nutty.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var skin = ModAPI.LoadTexture("sprites/Nutty.png");
                     
                        var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                        
                        var bone = ModAPI.LoadTexture("sprites/bone.png");
                     
                        person.SetBodyTextures(skin, flesh, bone, 4);

                        var head = Instance.transform.GetChild(5);
                        var cObj = new GameObject("hair");
                        cObj.transform.SetParent(Instance.transform.Find("Head"));
                        cObj.transform.localPosition = new Vector3(0f, 0f);
                        cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj.transform.localScale = new Vector3(0.5f, 0.5f);
                        var cSpr = cObj.AddComponent<SpriteRenderer>();
                        cSpr.sprite = ModAPI.LoadSprite("sprites/NuttyH.png");
                        cSpr.sortingLayerName = "Middle";

                        var tail1 = Instance.transform.GetChild(5);
                        var cObj1 = new GameObject("tails");
                        cObj1.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        cObj1.transform.localPosition = new Vector3(-0.30f, 0f);
                        cObj1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj1.transform.localScale = new Vector3(1f, 1f);
                        var cSpr1 = cObj1.AddComponent<SpriteRenderer>();
                        cSpr1.sprite = ModAPI.LoadSprite("sprites/NuttyT.png");
                        cSpr1.sortingLayerName = "Middle";

                        foreach (var limb in person.Limbs)
                        {
                            var HumanSprites = limb.gameObject.GetOrAddComponent<RandomHumanTextureBehaviour>();
                            HumanSprites.person = person;
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("sprites/Nutty.png")); 
                            HumanSprites.Textures.Add(ModAPI.LoadTexture("sprites/NuttyCrazy.png")); 

                        }

                     }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Petunia",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "This sweet smelling skunk never raises a stink! You won't have to hold your nose around this friendly creature.",
                    CategoryOverride = ModAPI.FindCategory("Happy Tree Friends PPG"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Petunia.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var skin = ModAPI.LoadTexture("sprites/Petunia.png");
                     
                        var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                        
                        var bone = ModAPI.LoadTexture("sprites/bone.png");
                     
                        person.SetBodyTextures(skin, flesh, bone, 4);

                        var head = Instance.transform.GetChild(5);
                        var cObj = new GameObject("hair");
                        cObj.transform.SetParent(Instance.transform.Find("Head"));
                        cObj.transform.localPosition = new Vector3(0f, 0f);
                        cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj.transform.localScale = new Vector3(0.5f, 0.5f);
                        var cSpr = cObj.AddComponent<SpriteRenderer>();
                        cSpr.sprite = ModAPI.LoadSprite("sprites/PetuniaFlo.png");
                        cSpr.sortingLayerName = "Middle";

                        var tail1 = Instance.transform.GetChild(5);
                        var cObj1 = new GameObject("tails");
                        cObj1.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        cObj1.transform.localPosition = new Vector3(-0.30f, 0f);
                        cObj1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj1.transform.localScale = new Vector3(1f, 1f);
                        var cSpr1 = cObj1.AddComponent<SpriteRenderer>();
                        cSpr1.sprite = ModAPI.LoadSprite("sprites/PetuniaT.png");
                        cSpr1.sortingLayerName = "Middle";

                     }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Sniffles",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "This brainy anteater loves to eat ants! Anyway you add it up, he's always getting his nose into trouble.",
                    CategoryOverride = ModAPI.FindCategory("Happy Tree Friends PPG"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Sniffles.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var skin = ModAPI.LoadTexture("sprites/Sniffles.png");
                     
                        var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                        
                        var bone = ModAPI.LoadTexture("sprites/bone.png");
                     
                        person.SetBodyTextures(skin, flesh, bone, 4);

                        var head = Instance.transform.GetChild(5);
                        var cObj = new GameObject("hair");
                        cObj.transform.SetParent(Instance.transform.Find("Head"));
                        cObj.transform.localPosition = new Vector3(0f, 0f);
                        cObj.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj.transform.localScale = new Vector3(0.5f, 0.5f);
                        var cSpr = cObj.AddComponent<SpriteRenderer>();
                        cSpr.sprite = ModAPI.LoadSprite("sprites/SnifflesN.png");
                        cSpr.sortingLayerName = "Middle";

                        var tail1 = Instance.transform.GetChild(5);
                        var cObj1 = new GameObject("tails");
                        cObj1.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        cObj1.transform.localPosition = new Vector3(-0.30f, 0f);
                        cObj1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj1.transform.localScale = new Vector3(1f, 1f);
                        var cSpr1 = cObj1.AddComponent<SpriteRenderer>();
                        cSpr1.sprite = ModAPI.LoadSprite("sprites/SnifflesT.png");
                        cSpr1.sortingLayerName = "Middle";

                     }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Splendid",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "This flying squirrel is always ready to swoop in for the rescue. Ever vigilant, he's definitely a cut above the rest.",
                    CategoryOverride = ModAPI.FindCategory("Happy Tree Friends PPG"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Splendid.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var skin = ModAPI.LoadTexture("sprites/Splendid.png");
                     
                        var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                        
                        var bone = ModAPI.LoadTexture("sprites/bone.png");
                     
                        person.SetBodyTextures(skin, flesh, bone, 4);

                        var tail1 = Instance.transform.GetChild(5);
                        var cObj1 = new GameObject("tails");
                        cObj1.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        cObj1.transform.localPosition = new Vector3(-0.30f, 0f);
                        cObj1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj1.transform.localScale = new Vector3(1f, 1f);
                        var cSpr1 = cObj1.AddComponent<SpriteRenderer>();
                        cSpr1.sprite = ModAPI.LoadSprite("sprites/SplendidT.png");
                        cSpr1.sortingLayerName = "Middle";

                     }
                }
            );

ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Toothy",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "The only thing bigger than this freckled-faced beaver's tail is his big 'ol buck teeth.",
                    CategoryOverride = ModAPI.FindCategory("Happy Tree Friends PPG"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumbnails/Toothy.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var skin = ModAPI.LoadTexture("sprites/Toothy.png");
                     
                        var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                        
                        var bone = ModAPI.LoadTexture("sprites/bone.png");
                     
                        person.SetBodyTextures(skin, flesh, bone, 4);

                        var tail1 = Instance.transform.GetChild(5);
                        var cObj1 = new GameObject("tails");
                        cObj1.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        cObj1.transform.localPosition = new Vector3(-0.30f, 0f);
                        cObj1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        cObj1.transform.localScale = new Vector3(1f, 1f);
                        var cSpr1 = cObj1.AddComponent<SpriteRenderer>();
                        cSpr1.sprite = ModAPI.LoadSprite("sprites/ToothyT.png");
                        cSpr1.sortingLayerName = "Middle";

                     }
                }
            );


          
        }  
    }

   public class RandomHumanTextureBehaviour : MonoBehaviour
    {
        private void Start()
        {
            this.phys = gameObject.GetComponent<PhysicalBehaviour>();
            chosenIndex = UnityEngine.Random.Range(0, Textures.Count - 0); 
            NextTexture();   
            phys.ContextMenuOptions.Buttons.Add(menuButton = new ContextMenuButton("NextTexture", "Next texture", "Switches to the next texture", new UnityAction[1]
            {
                (UnityAction) (() =>
                {
                    NextTexture();
                    foreach (var limb in person.Limbs)
                    {
                        if (limb.GetComponent<RandomHumanTextureBehaviour>())
                        {
                            limb.GetComponent<RandomHumanTextureBehaviour>().chosenIndex = chosenIndex;
                        }
                    }
                })
            }));     
            phys.ContextMenuOptions.Buttons.Add(menuButton = new ContextMenuButton("PreviousTexture", "Previous texture", "Switches to the previous texture", new UnityAction[1]
            {
                (UnityAction) (() =>
                {
                    PreviousTexture();
                    foreach (var limb in person.Limbs)
                    {
                        if (limb.GetComponent<RandomHumanTextureBehaviour>())
                        {
                            limb.GetComponent<RandomHumanTextureBehaviour>().chosenIndex = chosenIndex;
                        }
                    }
                })
            }));
        }
        private void NextTexture()
        {
            chosenIndex += 1;
            if (chosenIndex > Textures.Count - 1)
            {
                chosenIndex = 0;
            }
            person.SetBodyTextures(Textures[chosenIndex]);
        }
        private void PreviousTexture()
        {
            chosenIndex -= 1;
            if (chosenIndex < 0)
            {
                chosenIndex = Textures.Count - 1;
            }
            person.SetBodyTextures(Textures[chosenIndex]);
        }

       public List<Texture2D> Textures = new List<Texture2D>();
       public int chosenIndex = -1;
       public PersonBehaviour person;
       private PhysicalBehaviour phys;
       private ContextMenuButton menuButton;
    
    
    }
}                 